Package com.ads.mm.etl.xml.mapping

# Class MMSystemMap

java.lang.Object
java.util.AbstractMap<K,V>
java.util.HashMap<K,V>
java.util.LinkedHashMap<String,MMDBSystem>
com.ads.mm.etl.xml.mapping.MMSystemMap

All Implemented Interfaces:
  `Serializable`, `Cloneable`, `Map<String,MMDBSystem>`

public class MMSystemMap extends LinkedHashMap<String,MMDBSystem>

Author:
  Syed Abdul Rahim
See Also:
  - Serialized Form

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static enum`
  `MMSystemMap.Type`

  ## Nested classes/interfaces inherited from class java.util.AbstractMap

  `AbstractMap.SimpleEntry<K extends Object,V extends Object>, AbstractMap.SimpleImmutableEntry<K extends Object,V extends Object>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MMSystemMap(MMMappingUtil mappingUtil)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addSystem(MMDBSystem mmdbSystem)`
  `MMDBSystem`
  `addSystem(String systemName)`
  `void`
  `associateMappings(MMSystemMap.Type mapType)`
  `MMDBColumn`
  `createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath)`
  `MMDBColumn`
  `createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath, String entityUid, String tableType, String tableBusEntityType, String envBusEntityType)`
  `MMDBColumn`
  `createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String primaryKeyFlag, String foreignKeyFlag, String foreignKeyTable, String foreignKeyColumn, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath, String tableBusEntityType, String envBusEntityType)`
  `MMDBColumn`
  `createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String primaryKeyFlag, String foreignKeyFlag, String foreignKeyTable, String foreignKeyColumn, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath, String entityUid, String tableType, String tableBusEntityType, String envBusEntityType)`
  `MMDBSystem`
  `ensureSystemExists(String systemName)`
  `MMDBTable`
  `ensureTableExists(String systemName, String environmentName, String schema, String tableName)`
  `MMDBTable`
  `ensureTableExists(String systemName, String environmentName, String schema, String tableName, String xpath)`
  `void`
  `fillAlongAdjustingMetadata(MMSystemMap.Type type, boolean addUnusedColumns, boolean fillMetadata)`
  `void`
  `fillCopyColumnDependencies()`
  `void`
  `fillEnvironmentDetails()`
  `MMDBColumn`
  `findColumnInPool(String systemName, String environmentName, String tableName, String columnName)`
  `MMDBColumn`
  `findColumnInPool(String systemName, String environmentName, String tableName, String columnName, String tblXPath, String colXPath)`
  `MMDBTable`
  `findFirstValidTable()`
  `MMDBSystem`
  `findSystem(String systemName)`
  `MMEnvironmentMap`
  `getAllEnvironments()`
  `MMDBSystem`
  `getFirstValidMMDBSystem()`
  `int`
  `getTablesCount()`
  `boolean`
  `isAddUnusedColumns()`
  `boolean`
  `isFillMetadata()`
  `void`
  `setAddUnusedColumns(boolean addUnusedColumns)`
  `void`
  `setFillMetadata(boolean fillMetadata)`
  `String`
  `toString()`
  `void`
  `toString(StringBuilder sbu)`

  ### Methods inherited from class java.util.LinkedHashMap

  `clear, containsValue, entrySet, forEach, get, getOrDefault, keySet, removeEldestEntry, replaceAll, values`

  ### Methods inherited from class java.util.HashMap

  `clone, compute, computeIfAbsent, computeIfPresent, containsKey, isEmpty, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, size`

  ### Methods inherited from class java.util.AbstractMap

  `equals, hashCode`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, containsKey, equals, hashCode, isEmpty, merge, put, putAll, putIfAbsent, remove, remove, replace, replace, size`

- ## Constructor Details

  - ### MMSystemMap

    public MMSystemMap(MMMappingUtil mappingUtil)

- ## Method Details

  - ### isAddUnusedColumns

    public boolean isAddUnusedColumns()
    Returns:
      the addUnusedColumns

  - ### setAddUnusedColumns

    public void setAddUnusedColumns(boolean addUnusedColumns)
    Parameters:
      `addUnusedColumns` - the addUnusedColumns to set

  - ### isFillMetadata

    public boolean isFillMetadata()
    Returns:
      the fillMetadata

  - ### setFillMetadata

    public void setFillMetadata(boolean fillMetadata)
    Parameters:
      `fillMetadata` - the fillMetadata to set

  - ### findSystem

    public MMDBSystem findSystem(String systemName)

  - ### addSystem

    public MMDBSystem addSystem(String systemName)

  - ### addSystem

    public void addSystem(MMDBSystem mmdbSystem)

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `AbstractMap<String,MMDBSystem>`

  - ### toString

    public void toString(StringBuilder sbu)

  - ### getAllEnvironments

    public MMEnvironmentMap getAllEnvironments()

  - ### fillEnvironmentDetails

    public void fillEnvironmentDetails() throws SQLException
    Throws:
      `SQLException`

  - ### fillCopyColumnDependencies

    public void fillCopyColumnDependencies()

  - ### getFirstValidMMDBSystem

    public MMDBSystem getFirstValidMMDBSystem()

  - ### findFirstValidTable

    public MMDBTable findFirstValidTable()

  - ### getTablesCount

    public int getTablesCount()

  - ### fillAlongAdjustingMetadata

    public void fillAlongAdjustingMetadata(MMSystemMap.Type type, boolean addUnusedColumns, boolean fillMetadata)

  - ### ensureTableExists

    public MMDBTable ensureTableExists(String systemName, String environmentName, String schema, String tableName)

  - ### ensureTableExists

    public MMDBTable ensureTableExists(String systemName, String environmentName, String schema, String tableName, String xpath)

  - ### ensureSystemExists

    public MMDBSystem ensureSystemExists(String systemName)

  - ### createColumnInPool

    public MMDBColumn createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath)

  - ### createColumnInPool

    public MMDBColumn createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath, String entityUid, String tableType, String tableBusEntityType, String envBusEntityType)

  - ### createColumnInPool

    public MMDBColumn createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String primaryKeyFlag, String foreignKeyFlag, String foreignKeyTable, String foreignKeyColumn, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath, String tableBusEntityType, String envBusEntityType)

  - ### createColumnInPool

    public MMDBColumn createColumnInPool(String systemName, String environmentName, String tableName, String columnName, String dataType, String defaultValue, String definitionComments, String identityFlag, String length, String maxValue, String minValue, String naturalKeyFlag, String nullableFlag, String percentNullValue, String precision, String scale, String primaryKeyFlag, String foreignKeyFlag, String foreignKeyTable, String foreignKeyColumn, String tableClass, String columnClass, String businessKeyFlag, String tableAlias, String logicalColumnName, String columnAlias, String columnComments, String sdiFlag, String sdiDescription, String xpath, String entityUid, String tableType, String tableBusEntityType, String envBusEntityType)

  - ### findColumnInPool

    public MMDBColumn findColumnInPool(String systemName, String environmentName, String tableName, String columnName)

  - ### findColumnInPool

    public MMDBColumn findColumnInPool(String systemName, String environmentName, String tableName, String columnName, String tblXPath, String colXPath)

  - ### associateMappings

    public void associateMappings(MMSystemMap.Type mapType)